Graphics3D 800, 600, 32, 2
SetBuffer BackBuffer()
AmbientLight 255, 255, 255

;Globs
Global FPS#

;Camera
Global Cam = CreateCamera()
PositionEntity Cam, 0, 2.6, -3.5
CameraClsColor Cam, 64, 127, 255
RotateEntity Cam, 40, 0, 0
CameraZoom Cam, 2

;Entity
Mesh = LoadMesh("Media\Teapot.x")
EntityFX Mesh, 2
Surf = GetSurface(Mesh, 1)
For i = 0 To CountVertices(Surf) - 1
  VertexColor(Surf, i, Rand(0, 255), Rand(0, 255), Rand(0, 255))
Next

fps# = 100
While Not KeyHit(1)
  TurnEntity Mesh, 0, 80.0 / fps#, 0

  ;FPS
  loops = loops + 1
  If MilliSecs() - time1 > 500 Then
    FPS# = loops * 2
    loops = 0
    time1 = MilliSecs()
  End If

  RenderWorld()
  UpdateDebugLine(10, 10)
  Flip 0
Wend
End

Function UpdateDebugLine(x = 0, y = 0)
cnt1 = 0: cnt2 = 0: cnt3 = 0: cnt4 = 0
Color 0, 0, 0
Rect x, y, 98, 25
Color 255, 255, 255
Rect x - 1, y - 1, 100, 27, False
Text x + 5, y + 5,  "FPS = " + Int(FPS)
End Function