Function rPositionEntity(e.Entity, x#, y#, z#)
e\X# = x#
e\Y# = y#
e\Z# = z#
End Function

Function rTranslateEntity(e.Entity, x#, y#, z#)
e\X# = e\X# + x#
e\Y# = e\Y# + y#
e\Z# = e\Z# + z#
End Function

Function rTurnEntity(e.Entity, x#, y#)
e\Pitch# = e\Pitch# + x#
e\Yaw# = e\Yaw# + y#
End Function

Function rRotateEntity(e.Entity, x#, y#)
e\Pitch# = x#
e\Yaw# = y#
End Function

Function rScaleEntity(e.Entity, x#, y#, z#)
e\sx# = x#
e\sy# = y#
e\sz# = z#
End Function

Function rCameraClsColor(e.Entity, col1, col2, col3)
e\ClsColor1 = col1
e\ClsColor2 = col2
e\ClsColor3 = col3
End Function

Function rCameraZoom(e.Entity, zoom#)
e\Zoom# = zoom#
End Function

Function rCameraProjMode(e.Entity, mode)
e\ProjMode = mode
End Function

Function rEntityX#(e.Entity)
Return e\X#
End Function

Function rEntityY#(e.Entity)
Return e\Y#
End Function

Function rEntityZ#(e.Entity)
Return e\Z#
End Function

Function rFreeEntity(e.entity)
For v.Vertex = Each Vertex
  If v\Entity = e Then
    Delete v\Vector3D
    Delete v
  EndIf
Next
For p.Polygon = Each Polygon
  If p\Entity = e Then Delete p
Next
FreeMatrix(e\Matrix)
Delete e
End Function

Function rFlipMesh(e.Entity)
e\Fliped = 1 - e\Fliped
End Function

Function rWireFrame(mode)
Wire = mode
End Function

Function rEntityColor(e.Entity, col1, col2, col3)
e\col1 = col1
e\col2 = col2
e\col3 = col3
End Function

Function rEntityVertexColorRandom(e.Entity, min = 0, max = 255)
For v.Vertex = Each Vertex
  If v\Entity = e Then
    v\col1 = Rand(min, max)
    v\col2 = Rand(min, max)
    v\col3 = Rand(min, max)
  EndIf
Next
End Function

Function rVertexCoords(v.Vertex, x#, y#, z#)
v\x# = x#
v\y# = y#
v\z# = z#
End Function

Function rVertexColor(v.Vertex, col1, col2, col3)
v\col1 = col1
v\col2 = col2
v\col3 = col3
End Function

Function rVertexX#(v.Vertex)
Return v\x#
End Function

Function rVertexY#(v.Vertex)
Return v\y#
End Function

Function rVertexZ#(v.Vertex)
Return v\z#
End Function

Function rTrisRendered()
Return Tris
End Function

Function rCameraViewPort(e.Entity, x, y, w, h)
e\ViewX = x
e\ViewY = y
e\ViewWidth = w
e\ViewHeight = h
End Function

Function rHideEntity(e.Entity)
e\vis = False
End Function

Function rShowEntity(e.Entity)
e\vis = True
End Function