Include "Lib_Engine.bb"
rInit 1024, 768, 32, 2

Global FPS#

;Camera
Global Cam.Entity = rCreateCamera()
rPositionEntity Cam, 11, 10, -2 
rCameraClsColor Cam, 64, 127, 255
rRotateEntity Cam, 35, 0

Global WaterGridSize = 20

;Entity
Dim wt.Vertex(WaterGridSize + 1, WaterGridSize + 1), wh(WaterGridSize + 1, WaterGridSize + 1)
Water.Entity = rCreateMesh()
For x = 1 To WaterGridSize + 1
  For z = 1 To WaterGridSize + 1
    wt(x, z) = rAddVertex(Water, x, 0, z)
    wh(x, z) = Rand(0, 360)
  Next
Next
For x = 1 To WaterGridSize
  For z = 1 To WaterGridSize
    rAddTriangle(Water, wt(x, z), wt(x, z + 1), wt(x + 1, z))
    rAddTriangle(Water, wt(x + 1, z + 1), wt(x + 1, z), wt(x, z + 1))
  Next
Next

While Not KeyHit(1)
  For x = 1 To WaterGridSize + 1
    For z = 1 To WaterGridSize + 1
      rVertexCoords wt(x, z), rVertexX(wt(x, z)), Sin(MilliSecs() / 3 + wh(x, z)) / 6, rVertexZ(wt(x, z))
      rVertexColor wt(x, z), 0, 0, rVertexY(wt(x, z)) * 100 + 200
    Next
  Next

  ;FPS
  loops = loops + 1
  If MilliSecs() - time1 > 500 Then
    FPS# = loops * 2
    loops = 0
    time1 = MilliSecs()
  End If

  rRenderWorld()
  UpdateDebugLine(10, 10)
  Flip 0
Wend
End