Graphics3D 400, 300, 32, 2

Sphere = LoadMesh("Model.3ds")
ConvertObject(Sphere, "Model.3d")

Function ConvertObject(Mesh, FileTo$)
Surf = GetSurface(Mesh, 1)
file = WriteFile(FileTo$)
WriteInt file, CountVertices(Surf)
WriteInt file, CountTriangles(Surf)
For v = 0 To CountVertices(Surf) - 1
  WriteFloat file, VertexX(Surf, v)
  WriteFloat file, VertexY(Surf, v)
  WriteFloat file, VertexZ(Surf, v)
Next
For t = 0 To CountTriangles(Surf) - 1
  WriteInt file, TriangleVertex(Surf, t, 0)
  WriteInt file, TriangleVertex(Surf, t, 1)
  WriteInt file, TriangleVertex(Surf, t, 2)
Next
End Function